(function () {
    "use strict";

    angular.module('core').controller('planoAbastecimentoDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$state', '$stateParams', '$q', '$alert', '$confirm', 'planoAbastecimentoService', 'lookupService', 'produtoService'];

    function controller($scope, $timeout, $state, $stateParams, $q, $alert, $confirm, planoAbastecimentoService, lookupService, produtoService) {
        $scope.initializeLayout('Plano de Abastecimento');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
            estoquePadrao: {
                Ideal: 0,
                Critico: 0
            },
            statusInicialplanoAbastecimento: 0,
            tabCorrente: 0,
            tabs: {
                Detalhes: 0,
                Produtos: 1,
            },
            filtro: {
                ativo: false,
                args: null
            }
        };

        $scope.view = {
            index: 0,
            views: { lista: 0, catalogo: 1 },
        }
        $scope.toggleView = function () {
            $scope.view.index = $scope.view.index == 0 ? 1 : 0;
        };
        $scope.pager = {
            page: 1,
            pageSize: 28,
        };

        $scope.adicionarProduto = function (event) {

            if (event.key === 'Enter') {

                event.preventDefault();
                if (!$scope.state.filtro.args.filtro.Codigo || $scope.state.filtro.args.filtro.Codigo == '') {


                    $scope.tools.toastr.error('Digite um codigo de produto');
                    return;
                }
                else {
                    var codigo = $scope.state.filtro.args.filtro.Codigo;

                    $scope.state.filtro = {
                        ativo: false,
                        args: {
                            filial: $scope.state.item.Filial,
                            filialOrigem: $scope.state.item.FilialOrigem,
                            planoAbastecimento: $scope.state.item.PlanoAbastecimento,
                            filtro: { Codigo: codigo }
                        }
                    };
                }
                $scope.getAllProdutos(true);
            }
        }
        $scope.getAllProdutos = function (nousingModal) {
            $scope.state.carregando = true;
            debugger
            if ($scope.state.filtro.args == null) {
                 
                $scope.state.filtro.args = {
                    filtro: { IndicaCadastroSimplificado: true, Status: 2, Ativo: 1 }
                }
            }
            else {
                if (!$scope.state.filtro.args.filtro)
                    $scope.state.filtro.args.filtro = {}
                $scope.state.filtro.args.filtro.IndicaCadastroSimplificado = true;
                $scope.state.filtro.args.filtro.Status = 2;
                $scope.state.filtro.args.filtro.Ativo = 1;
            }
            
            $scope.state.filtro.args.take = 1000
                
            produtoService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        // debugger
                        //   $scope.state.filtro.args.filtro.Codigo = "";
                        if (response.Status < 0) {
                            if (!nousingModal)
                                $scope.popups.addProdutos.onToggle();
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            $scope.state.carregando = false;
                        } else {
                            debugger
                            if (!nousingModal)
                                $scope.popups.addProdutos.onToggle();
                            var produtos = response.Data;
                            var itens = $scope.state.item.Itens;
                            if (!produtos || produtos.length <= 0) {
                                $scope.state.carregando = false;
                                $scope.tools.toastr.error('A pesquisa efetuada nao retornou nenhum produto');
                                return
                            }
                            for (var i = 0; i < produtos.length; i++) {

                                var produto = produtos[i];
                                var existe = itens.some(function (item) {
                                    return item.Produto.ID === produto.ID;
                                });
                         
                                if (!existe) {
                                    itens.push({
                                        Produto: {
                                            ID: produto.ID,
                                            Codigo: produto.Codigo,
                                            Nome: produto.Nome,
                                            Grupo: produto.Grupo,
                                            Imagem: produto.Imagem
                                                ? {
                                                    ID: produto.Imagem.ID,
                                                    Url: produto.Imagem.Url
                                                }
                                                : null
                                        },
                                        EstoqueIdeal: $scope.state.estoquePadrao.Ideal ?? 0,
                                        EstoqueCritico: $scope.state.estoquePadrao.Critico ?? 0,
                                        PlanoAbastecimento: $scope.state.item.PlanoAbastecimento,
                                        Deleted: false,
                                        ID: crypto.randomUUID ? crypto.randomUUID() : gerarGuid(),
                                    });

                                }

                            }
                            $scope.state.carregando = false;

                        }

                    },
                    function (_error) {
                        $scope.state.filtro.args.filtro.Codigo = "";
                        $scope.state.carregando = false;
                        if (!nousingModal)
                            $scope.popups.addProdutos.onToggle();
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        function gerarGuid() {
            return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
                var r = Math.random() * 16 | 0;
                var v = c === 'x' ? r : (r & 0x3 | 0x8);
                return v.toString(16);
            });
        }
        $scope.removerItem = function (item, $event) {

            if ($event) {
                $event.stopPropagation();
            }

            var lista = $scope.state.item.Itens;
            var index = lista.indexOf(item);

            if (index > -1) {
                lista.splice(index, 1);
            }

        };
        //$scope.getPageItems = function () {
        //    if (!$scope.state || !$scope.state.item || !$scope.state.item.Itens)
        //        return [];

        //    var start = ($scope.pager.page - 1) * $scope.pager.pageSize;
        //    var end = start + $scope.pager.pageSize;

        //    return $scope.state.item.Itens.slice(start, end);
        //};

        //$scope.getTotalItems = function () {
        //    return ($scope.state && $scope.state.item && $scope.state.item.Itens)
        //        ? $scope.state.item.Itens.length
        //        : 0;
        //};

        //$scope.getTotalPages = function () {
        //    var total = $scope.getTotalItems();
        //    return Math.max(1, Math.ceil(total / $scope.pager.pageSize));
        //};
        $scope.filtroLista = {
            Grupo: {}
        }
        $scope.getFilteredItems = function () {
            if (!$scope.state || !$scope.state.item || !$scope.state.item.Itens)
                return [];

            return $scope.state.item.Itens.filter($scope.matchSearch);
        };

        $scope.getPageItems = function () {
            var items = $scope.getFilteredItems();

            var start = ($scope.pager.page - 1) * $scope.pager.pageSize;
            var end = start + $scope.pager.pageSize;

            return items.slice(start, end);
        };

        $scope.matchSearch = function (item) {
    
            var q = $scope.filtroLista.Grupo.Nome;
            if (!q) return true;
            if ($scope.filtroLista.Grupo.Codigo)
            debugger
            var nome = (item && item.Produto && item.Produto.Grupo.Nome ? item.Produto.Grupo.Nome : "").toString();
           // var codigo = (item && item.Produto && item.Produto.Grupo.Codigo ? item.Produto.Grupo.Codigo : "").toString().toLowerCase();

            return nome.indexOf(q) !== -1; //|| codigo.indexOf(q) !== -1;
        };

        $scope.getTotalItems = function () {
            return ($scope.state && $scope.state.item && $scope.state.item.Itens)
                ? $scope.getFilteredItems().length
                : 0;
        };

        $scope.getTotalPages = function () {
            var total = $scope.getTotalItems();
            return Math.max(1, Math.ceil(total / $scope.pager.pageSize));
        };


        $scope.getStart = function () {
            return ($scope.pager.page - 1) * $scope.pager.pageSize;
        };

        $scope.setPage = function (p) {
            var totalPages = $scope.getTotalPages();
            if (p < 1) p = 1;
            if (p > totalPages) p = totalPages;
            $scope.pager.page = p;
        };

        $scope.prevPage = function () {
            $scope.setPage($scope.pager.page - 1);
        };
        $scope.nextPage = function () { $scope.setPage($scope.pager.page + 1); };

        $scope.popups = {
            addProdutos: {
                ativo: false,
                onToggle: function () {
                    debugger
                    $scope.popups.addProdutos.ativo = !$scope.popups.addProdutos.ativo
                }
            },
        };
        $scope.auxiliar = {
            filial: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFilial({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            }, marca: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllMarca({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            grupo: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllGrupo({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            fornecedor: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFornecedor({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            planoAbastecimento: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllplanoAbastecimento({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            planoAbastecimentoService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        } else {
                            $scope.state.item = response.Data;
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    }
                );
        };
        $scope.refresh = function () {
            $scope.get();
        };

        $scope.save = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;


            if (!angular.isUndefined($scope.state.item.Midias) && !angular.isUndefined($scope.state.item.Midias.length > 0)) {


                if (!angular.isUndefined(document.querySelector('input[name="principalItem"]:checked')) && document.querySelector('input[name="principalItem"]:checked') !== null) {

                    var itemPrincipal = document.querySelector('input[name="principalItem"]:checked').getAttribute("itemindex");

                    for (var i = 0; i < $scope.state.item.Midias.length; i++) {
                        $scope.state.item.Midias[i].IndicaPrincipal = false;
                    }


                    setTimeout(function () {
                        if (!angular.isUndefined(itemPrincipal))
                            $scope.state.item.Midias[itemPrincipal].IndicaPrincipal = true;

                    }, 50)

                }
                else {

                    if (!angular.isUndefined($scope.state.item.Midias[0])
                        && !angular.isUndefined($scope.state.item.Midias[0].IndicaPrincipal))
                        $scope.state.item.Midias[0].IndicaPrincipal = true;
                }
            }

            setTimeout(function () {
                planoAbastecimentoService
                    .save($scope.state.item)
                    .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ text: response.Message, title: $scope.Title });
                            } else {
                                $scope.state.item = response.Data;
                                $scope.historyBack();
                            }
                            $scope.state.carregando = false;
                            $scope.state.vazio = !$scope.state.item;
                        },
                        function (_error) {
                            $scope.state.carregando = false;
                            $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        }
                    );
            }, 200)
        };
        $scope.delete = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            planoAbastecimentoService
                .delete($scope.state.item.ID)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $alert({ text: response.Message, title: $scope.Title });
                        }
                        else {
                            $scope.historyBack();
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    }
                );
        }
        $scope.prepare = function () {
            $scope.state.vazio = false;
            planoAbastecimentoService
                .prepare($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        } else {
                            $scope.state.item = response.Data;
                        }
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    });
        };


        /*Inicializa funções*/
        $scope.initialize();

    }

})();